#include <algorithm>
#include <iostream>
#include <iterator>
#include <set>
using namespace std;

int main() {
	const int f[] = { 2, 4, 4, 4, 6, 6, 8 }, g[] = { 3, 4, 4, 6, 9, 9 };
	const multiset<int> a(f, f + 7), b(g, g + 6);
	ostream_iterator<int> oi(cout, "  ");
	cout << "a:  ";
	copy(a.begin(), a.end(), oi);
	cout << "\nb:  ";
	copy(b.begin(), b.end(), oi);
	cout << "\nset_union:  ";
	set_union(a.begin(), a.end(), b.begin(), b.end(), oi);
	cout << "\nset_intersection:  ";
	set_intersection(a.begin(), a.end(), b.begin(), b.end(), oi);
	cout << "\nset_difference:  ";
	set_difference(a.begin(), a.end(), b.begin(), b.end(), oi);
	cout << "\nset_symmetric_difference:  ";
	set_symmetric_difference(a.begin(), a.end(), b.begin(), b.end(), oi);
	cout << "\nincludes: " << boolalpha
		<< includes(a.begin(), a.end(), b.begin(), b.end()) << endl;
}
