#include <set>
#include <algorithm>
#include <iterator>
#include <iostream>
#include "smartptr.h"
#include "wp_objekte.h"
#include "wertpapier.h"
using namespace std;

template<class T> inline
ostream& operator<<(ostream& os, smart_ptr<T> sp) { return os << *sp; }

int main() {
	typedef set<smart_ptr<Wertpapier> > WPSet;
	WPSet zeigermenge(wp, wp + n);
	copy(zeigermenge.begin(), zeigermenge.end(),
		ostream_iterator<WPSet::value_type>(cout, "\n"));
	WPSet::iterator iter = zeigermenge.find(smart_ptr<Wertpapier>(wp[3]));
	if (iter != zeigermenge.end())
		cout << "\nGefunden: " << *iter << endl;
}
