#include <functional>
using namespace std;

template<class Vergleich>
class X {
public:
	explicit X(int ii, Vergleich v = Vergleich()) : i(ii), vgl(v) { }
	bool operator<(const X& x) const { return vgl(i, x.i); }
private:
	int i;
	Vergleich vgl;
};

inline bool kleiner(int x, int y) { return x < y; }
inline bool groesser(int x, int y) { return x > y; }

int main() {
	X<less<int> > x1(1);
	X<greater<int> > x2(2);
	typedef X<pointer_to_binary_function<int, int, bool> > XX;
	XX x3(3, ptr_fun(kleiner));
	XX x4(4, ptr_fun(groesser));
	if (x1 < x1) ;
	if (x2 < x2) ;
	if (x3 < x3) ;
	if (x4 < x4) ;
}
