#include <algorithm>
#include <functional>
#include <iterator>
#include <iostream>
#include <utility>
using namespace std;
using namespace std::rel_ops;

class Element {
public:
	Element(int i) : wert(i), index(nr++) { }
	friend ostream& operator<<(ostream& os, const Element& p)
		{ return os << p.wert << '-' << p.index; }
	bool operator<(const Element& p) const { return wert < p.wert; }
private:
	int wert, index;
	static int nr;
};

int Element::nr = 0;

int main() {
	Element f[] = { 3, 1, 0, 6, 3, 1, 0, 6 };
	cout << "vor der Sortierung: ";
	copy(f, f + 8, ostream_iterator<Element>(cout, "  "));
	stable_sort(f, f + 8);
	cout << "\naufsteigend sortiert: ";
	copy(f, f + 8, ostream_iterator<Element>(cout, "  "));
	stable_sort(f, f + 8, greater<Element>());
	cout << "\nabsteigend sortiert: ";
	copy(f, f + 8, ostream_iterator<Element>(cout, "  "));
}
