#include <stdexcept>
#include <iterator>
#include <vector>
#include <iostream>
using namespace std;

inline int v5(const vector<int>& v) throw(out_of_range) { return v.at(5); }

int main() {
	vector<int> v(5);
	for (vector<int>::size_type i = 0; i < v.size(); ++i)
		v[i] = i + 1;
	v.push_back(9);
	if (v.back() != 9)
		cout << "Hier stimmt etwas nicht.\n";
	v.pop_back();
	v.front() = 0;
	copy(v.begin(), v.end(), ostream_iterator<int>(cout, "  "));
	try {
		cout << v5(v);
	} catch(out_of_range x) {
		cout << "\nAusnahme out_of_range: " << x.what();
	}
}
