#include <iostream>
#include <algorithm>
#include <functional>
#include <iterator>
using namespace std;

int main() {
	int f[] = { 0, 1, 4, 9, 16, 25, 36, 49, 64, 81 };
	const int n = sizeof f / sizeof *f;
	int* z = find_if(f, f + n, bind2nd(greater<int>(), 50));
	if (z != f + n)
		cout << *z << " ist der erste Wert grer 50" << endl;
	z = find_if(f, f + n, bind1st(greater<int>(), 50));
	if (z != f + n)
		cout << *z << " ist der erste Wert kleiner 50" << endl;
	transform(f, f + n, ostream_iterator<int>(cout, "  "),
		bind1st(plus<int>(), 1));
	cout << '\n';
	transform(f, f + n, ostream_iterator<int>(cout, "  "),
		bind2nd(plus<int>(), 1));
}
