#include <iostream>
#include <algorithm>
#include <functional>
#include <vector>
using namespace std;

int main() {
	// vordefinierter Feldtyp, suchen mit find
	const int f[] = { 0, 1, 4, 9, 16, 25, 36, 49, 64, 81 };
	const int n = sizeof f / sizeof *f;
	const int* z = find(f, f + n, 25);
	if (z != f + n)
		cout << "25 in f gefunden\n";

	// Container vector, suchen mit find_if
	vector<int> v(f, f + n);    // v wird mit den Werten von f initialisiert
	vector<int>::iterator
		i = find_if(v.begin(), v.end(), bind2nd(greater<int>(), 50));
	if (i != v.end())
		cout << *i << " ist der erste Wert > 50" << endl;
}
