#include <fstream>
#include <iostream>
#include <iomanip>
using namespace std;

int main(int argc, char* argv[]) {
	if (argc != 2) {
		cerr << "Aufruf: " << argv[0] << " dateiname\n";
		return 1;
	}
	ifstream datei(argv[1], ios::in | ios::binary);
	if (!datei) {
		cerr << "Die Datei " << argv[1] << " konnte nicht geffnet werden.\n";
		return 2;
	}
	cout << hex << uppercase << setfill('0');
	const unsigned int anz = 16;
	char puffer[anz];
	do {
		cout << setw(8) << datei.tellg() << " | ";
		datei.read(puffer, anz);
		if (const streamsize n = datei.gcount()) {
			for (int i = 0; i < n; ++i)
				cout << setw(2) << static_cast<unsigned int>(puffer[i] & 0xff) << ' ';
			for (int j = n; j < anz; ++j)
				cout << "   ";
			cout << "| ";
			for (int k = 0; k < n; ++k)
				cout << ((static_cast<unsigned int>(puffer[k]) >= ' ') ? puffer[k] : '.');
			cout << "\n";
		}
	} while (datei);
	return 0;
}
