#include <fstream>
#include <iostream>
using namespace std;

int main(int argc, char* argv[]) {
	if (argc != 3) {
		cerr << "Aufruf: " << argv[0] << " Quelldatei Zieldatei\n";
		return 1;
	}
	ifstream in(argv[1], ios_base::in | ios_base::binary);
	if (!in) {
		cerr << "Die Datei " << argv[1] << " konnte nicht geffnet werden.\n";
		return 2;
	}
	ofstream out(argv[2], ios_base::out | ios_base::binary);
	if (!out) {
		cerr << "Die Datei " << argv[2] << " konnte nicht geffnet werden.\n";
		return 3;
	}
	cout << argv[1] << " wird nach " << argv[2] << " kopiert: ";
	out << in.rdbuf();
	if (out && in)
		cout << "ok\n";
	else
		cout << "Fehler!\n";
	return 0;
}
