#include <iostream>
using namespace std;

class B {
public:
	B(int i) : b(i) { }
	friend ostream& operator<<(ostream& os, const B& b) { return b.ausgeben(os); }
protected:
	virtual ostream& ausgeben(ostream& os) const { return os << b; }
private:
	int b;
};

class A : public B {
public:
	A(int i, int j) : B(i), a(j) { }
protected:
	ostream& ausgeben(ostream& os) const {
		B::ausgeben(os);
		return os << " und " << a;
	}
private:
	int a;
};

inline void test(const B& x) { cout << x << endl; }

int main() {
	A a(1, 2);
	test(a);
}
