#include <iostream>
using namespace std;

int main() {
	const ios_base::fmtflags standard_flags = cout.flags();
	cout << "Voreinstellung fr bool: " << true << " und " << false << endl;
	cout.setf(ios_base::boolalpha);
	cout << "mit boolalpha: " << true << " und " << false << endl;

	const double d = 123.456;
	cout << "Voreinstellung fr Gleitkommazahlen: " << d << endl;
	cout.setf(ios_base::showpoint);
	const streamsize standard_precision = cout.precision(8);
	cout << "8 Stellen: " << d << endl;
	cout.precision(2);
	cout << "2 Stellen: " << d << endl;

	cout.setf(ios_base::scientific, ios_base::floatfield);
	cout << "scientific mit 2 Nachkommastellen: " << d << endl;
	cout.setf(ios_base::fixed, ios_base::floatfield);
	cout << "fixed mit 2 Nachkommastellen: " << d << " (gerundet!)\n";

	const long x = 107187;
	cout << "Voreinstellung fr ganzzahlige Werte: " << x << endl;

	cout.setf(ios_base::showbase);
	cout.setf(ios_base::hex, ios_base::basefield);
	cout << "hexadezimal: " << x << endl;
	cout.setf(ios_base::oct, ios_base::basefield);
	cout << "oktal: " << x << endl;
	cout.setf(ios_base::dec, ios_base::basefield);
	cout << "dezimal: " << x << endl;

	cout.setf(ios_base::showpos);
	cout << "mit positivem Vorzeichen: " << x << ", " << 0 << endl;

	cout.setf(ios_base::unitbuf);
	cout.setf(ios_base::right, ios_base::adjustfield);
	cout.width(10);
	cout << x << " (right)\n";
	cout.setf(ios_base::internal, ios_base::adjustfield);
	cout.width(10);
	cout << x << " (internal)\n";
	cout.setf(ios_base::left, ios_base::adjustfield);
	cout.width(10);
	cout << x << " (left)\n";

	cout.flags(ios_base::uppercase | ios_base::hex | ios_base::scientific);
	cout << "uppercase, hex und scientific: " << x << ", " << d << endl;

	cout.flags(standard_flags);
	cout.precision(standard_precision);
	cout << "nochmal mit Voreinstellung: " << x << ", " << d << endl;
}
