#include <valarray>
#include <iostream>
using namespace std;

template<class T>
ostream& operator<<(ostream& os, const valarray<T>& v) {
	for (size_t i = 0; i < v.size(); ++i)
		os << v[i] << "  ";
	return os;
}

int main() {
	const int f[] = { 10, 11, 12, 13, 14, 15, 16 };
	valarray<int> v(f, 7);
	cout << "v = " << v << endl;
	const size_t indizes[] = { 1, 2, 4, 6 };
	valarray<size_t> ind(indizes, 4);
	cout << "ind = " << ind << endl;
	cout << "v[ind] = " << valarray<int>(v[ind]) << endl;
	v[ind] *= valarray<int>(-1, ind.size());
	cout << "v = " << v << endl;
}
