#include <valarray>
#include <iostream>
using namespace std;

template<class T>
ostream& operator<<(ostream& os, const valarray<T>& v) {
	for (size_t i = 0; i < v.size(); ++i)
		os << v[i] << "  ";
	return os;
}

int main() {
	const int f[] = { 1, -3, -5, 7, -9, 2 };
	valarray<int> v(f, 6);
	cout << "v = " << v << endl;
	valarray<bool> b(v < 0);
	cout << "b = " << boolalpha << b << endl;
	cout << "v[b] = " << valarray<int>(v[b]) << endl;
	v[b] = 0;
	cout << "v = " << v << endl;
}
