#include <valarray>
#include <algorithm>
#include <iostream>
using namespace std;

template<class T>
ostream& operator<<(ostream& os, const valarray<T>& v) {
	for (size_t i = 0; i < v.size(); ++i)
		os << v[i] << "  ";
	return os;
}

int main() {
	const int f[] = { 1, 3, 5, 7, 9 };
	valarray<int> x(f, 5), y(5);
	for (size_t i = 0; i < y.size(); ++i)
		y[i] = i;
	cout << "x = " << x << "\ny = " << y << endl;
	reverse(&x[0], &x[x.size()]);
	x -= 1;
	cout << "x = " << x << endl;
	valarray<int> z = abs(x - y);
	cout << "z = " << z;
	cout << "\nSumme = " << z.sum() << endl;
	cout << "cshift(2) = " << z.cshift(2) << endl;
	valarray<bool> b(z > 1);
	cout << "b = " << boolalpha << b << endl;
}
